#include <CellModel.h>

/* Copyright (c) 2003 by A BIG Corporation.  All Rights Reserved */

/***
   NAME
     Beeler
   PURPOSE
     implements the odes of the Beeler-Reuter model
   NOTES
     
   HISTORY
     monicaha - Jun 17, 2003: Created.
***/

#ifndef BEELER
#define BEELER

class Beeler : public CellModel
{
protected:

	real T0, tpeak, Trtau;
	real gNa, gNaC, gs; 
	real V, eNa, Ca, m, h, j, x, d, f, gate_m_slow, gate_h_slow;
	real iNa, iK, ix, is;
	real am,bm,ah,bh,aj,bj,ax,bx,ad,bd,af,bf;
	real stim_current, stim_start, stim_stop;
	real Cm;
	real G;
 	
/* methods */

	virtual void computeCurrents(const Vec(real)& y, real t);
	virtual void computeGateCoefs(const Vec(real)& y);
	real totalCurrent();
	void setConstants();

 public:

	Beeler () {
		DPTRACE("BeelerReuter constructor"); 
		setConstants();
	}
	
	~Beeler () {
	}

//  void evalStateDot (Vec(real)& f, const Vec(real)& y, real t)  ;
	virtual void evalStateDot(Vec(real)& ydot, const DynamicState& s);

	real ionicCurrent(Vec(real)& y, real t) { 
		computeCurrents(y,t);
		return totalCurrent();
	}

	int evalSize() const {return 9;}
	static void defineStatic (MenuSystem& menu, int level = MAIN);
	
	void define (MenuSystem& menu, int level = MAIN) 
		{defineStatic (menu,level);}
	
	virtual void scan   (MenuSystem& menu); 
	virtual void setParameters(Ptv(real)& p );
};
#endif /* BEELER */
