#include <Cubic.h>


void Cubic:: defineStatic (MenuSystem& menu, int level)
{
  DPTRACE("Cubic::define");
  String description = "Parameters for the Cubic Nagumo model";
  String command = "Cubic";
  MenuSystem::makeSubMenuHeader (menu, description, command, level, 'P');

  menu.addItem(level,"ode solver", "OdeSolver" ,
               "class name in OdeSolver hirarchy",
               "Euler1",
               //validationString(hierODEsolver())
               "Euler1"
               );
  /*
  menu.addItem (level, "Initial conditions", "init_cond",
                "Initial value for V",
                "-50 0", "S");
  */

  menu.addItem (level, "V0", "V0",
                "Some real good explentaion",
                "-85", "S");
  menu.addItem (level, "V1", "V1",
                "Some real good explentaion",
                "-65", "R1");
  menu.addItem (level, "V2", "Vpeak",
                "Some real good explentaion",
                "40", "R1");
  menu.addItem (level, "A value", "A",
                "Some real good explentaion",
                "0.04", "R1"); // 0.00001664
  CellModel:: defineStatic (menu, level); 
}

void Cubic:: scan (MenuSystem& menu)
{
  DPTRACE("Cubic::scan");

  v0 = menu.get("V0").getReal();
  v1 = menu.get("V1").getReal();
  v2 = menu.get("V2").getReal();
  A =  menu.get("A value").getReal();  

  y0.redim(evalSize());
  //y0.scan(menu.get("Initial conditions"));
 
 CellModel::scan(menu);

  
}
