#ifndef Cubic_h_IS_INCLUDED
#define Cubic_h_IS_INCLUDED

#include<CellModel.h>
#include<ODEsolver_prm.h>

class Cubic : public CellModel
{
protected:

  real		v0, v1, v2, A;

public:

 Cubic ()
  {
    DPTRACE("Cubic constructor"); 
  }

 ~Cubic () {}


 void evalStateDot (Vec(real)& dy, const DynamicState& s)  
  {  //   DPTRACE("Cubic equation"); 
    dy(1) = -A*A*(s.y(1)-v0)*(s.y(1)-v1)*(s.y(1)-v2); 
  }

  int evalSize() const {return 1;}

  real ionicCurrent(Vec(real)& V, real /*t*/)
    { return 0; }


  static void defineStatic (MenuSystem& menu, int level = MAIN);
  
  void define (MenuSystem& menu, int level = MAIN) 
     {defineStatic (menu,level);}

  virtual void scan   (MenuSystem& menu); 
  virtual void setParameters(Ptv(real)& /*p*/ ) {}
};

#endif
