#ifndef FK_h_IS_INCLUDED
#define FK_h_IS_INCLUDED

#include<CellModel.h>
#include<ODEsolver_prm.h>

class FK : public CellModel
{
 protected:

  real v_c, vg, tgm1, tgm2, thm, tgp, thp;
  real td, to, tr, tsi, k, vsi;

 public:

  FK ()
  {
    DPTRACE("FK constructor"); 
  }

 ~FK () {}


 void evalStateDot (Vec(real)& dy, const DynamicState& s);
 
 int evalSize() const {return 3;}
 
 //not necessary with current splitting technique:
 real ionicCurrent(Vec(real)& V, real /*t*/)
   { return 0;  }
 

 static void defineStatic (MenuSystem& menu, int level = MAIN);
 
 void define (MenuSystem& menu, int level = MAIN) 
   {defineStatic (menu,level);}

 virtual void scan   (MenuSystem& menu); 
 virtual void setParameters(Ptv(real)& /*p*/ ) {}
};

#endif
