#include <FitzHugh.h>


void FitzHugh:: defineStatic (MenuSystem& menu, int level)
{
  DPTRACE("FitzHugh::define");
  String description = "Parameters for the FitzHugh Nagumo model";
  String command = "FitzHugh";
  MenuSystem::makeSubMenuHeader (menu, description, command, level, 'P');

  menu.addItem(level,"ode solver", "OdeSolver" ,
               "class name in OdeSolver hirarchy",
               "Euler1",
               //validationString(hierODEsolver())
               "Euler1"
               );

  menu.addItem (level, "Initial conditions", "init_cond",
                "Initial value for V and v",
                "-50 0", "S");

  menu.addItem (level, "Rest platau", "Vrest",
                "Some real good explentaion",
                "-85", "I1");
  menu.addItem (level, "Threshold value", "Vthreshold",
                "Some real good explentaion",
                "-68.75", "I1");
  menu.addItem (level, "Peak value", "Vpeak",
                "Some real good explentaion",
                "40", "I1");
  menu.addItem (level, "k value", "k",
                "Some real good explentaion",
                "0.0000416", "S"); // 0.00001664
  menu.addItem (level, "l value", "l",
                "Some real good explentaion",
                "0.625", "S");
  menu.addItem (level, "b value", "b",
                "Some real good explentaion",
                "0.013", "S");

  CellModel:: defineStatic (menu, level); 
}

void FitzHugh:: scan (MenuSystem& menu)
{
  DPTRACE("FitzHugh::scan");

  Vrest = menu.get("Rest platau").getInt();
  Vthreshold = menu.get("Threshold value").getInt();
  Vpeak = menu.get("Peak value").getInt();
  k =  menu.get("k value").getReal();  
  l =  menu.get("l value").getReal();  
  b =  menu.get("b value").getReal();  

  y0.redim(evalSize());
  y0.scan(menu.get("Initial conditions"));
 
 CellModel::scan(menu);

  cout << "k: "  << k << " l: "  << l << " b: "  << b << "\n";
//  cout << y0 << endl;
}


