
                                                                 // -*- C++ -*-
// $Id: FitzHugh.h,v 1.1.1.1 2003/11/25 16:35:31 glennli Exp $
// prevent multiple inclusion of FitzHugh.h
#ifndef FitzHugh_h_IS_INCLUDED
#define FitzHugh_h_IS_INCLUDED

#include<CellModel.h>
#include<ODEsolver_prm.h>

// ------------------------- FitzHugh -----------------------

/*<FitzHugh:*/

class FitzHugh : public CellModel
{
protected:

  real		Vrest,Vthreshold,Vpeak,k,l,b;

public:

  FitzHugh ()
  {
    DPTRACE("FitzHugh constructor"); 
  }

 ~FitzHugh () {}


 void evalStateDot (Vec(real)& dy, const DynamicState& s)  
  {  //   DPTRACE("FitzHugh equation"); 
    dy(1) = -k*(s.y(1)-Vrest)*(s.y(2)+(s.y(1)-Vthreshold)*(s.y(1)-Vpeak));
    dy(2) = l*(s.y(1)-Vrest) - b*s.y(2);
//    cout << y(1) << " "  << y(2) << " "  << k << " " << l << " "  << b << " "  << Vrest << "\n";   
//    cout << f(1) << " " << f(2) << "\n"; 
  }

  int evalSize() const {return 2;}

  real ionicCurrent(Vec(real)& V, real /*t*/)
    { return k*(V(1)-Vrest)*(V(2)+(V(1)-Vthreshold)*(V(1)-Vpeak)); }


  static void defineStatic (MenuSystem& menu, int level = MAIN);
  
  void define (MenuSystem& menu, int level = MAIN) 
     {defineStatic (menu,level);}

  virtual void scan   (MenuSystem& menu); 
  virtual void setParameters(Ptv(real)& /*p*/ ) {}
//  void resultReport ();  
};
/*>FitzHugh:*/

/*Class:FitzHugh

NAME: FitzHugh - Implemts the FitzHugh-Nagumo cell model

SYNTAX:	           @FitzHugh

KEYWORDS:          

   FitzHugh, CellModel


DESCRIPTION:       

   Sub class of CellModel

CONSTRUCTORS AND INITIALIZATION:


MEMBER FUNCTIONS:

"scan" - reads and initializes ...

SEE ALSO:          

   CellModel

DEVELOPED BY:   


AUTHOR:	        

   Glenn Terje Lines

End:
*/
#endif
/*
$Log: FitzHugh.h,v $
Revision 1.1.1.1  2003/11/25 16:35:31  glennli
INF-5610 oblig

*/


