#include <create.h>
#include <CellModel.h>


static const char* subclass_table_ODE[] =
{
  "FitzHugh",
  "LuoRudy",
  "Winslow", 
  "Ischemic",
  "Winslow_opt",
  "Beeler",
  NULL
};


const char** hierODE () { return subclass_table_ODE; }

CellModel* createODE (const String& problem)
{
  CellModel* ptr = NULL;

  DPTRACE("createODE");
  if (EQ(problem,FitzHugh))
    ptr = new FitzHugh();
  else
    if (EQ(problem,LuoRudy))
      ptr = new LuoRudy();
  else
    if (EQ(problem,Winslow))
      ptr = new Winslow();
  else
    if (EQ(problem,Winslow_opt))
      ptr = new Winslow_opt();
  else
    if (EQ(problem, Cubic))
      ptr = new Cubic();
 else
    if (EQ(problem, Beeler))
      ptr = new Beeler();
else
      errorFP("createODE","Cannot make object of class %s",
	    problem.chars());
  return ptr;
}





