#include <CombinedExplicitODE.h>

INIT_CLASS_INFO(CombinedExplicitODE)

//-----------------------------------------------------------------------------
void CombinedExplicitODE::add(DynSys& problem)
//-----------------------------------------------------------------------------
{
  CombinedDynSys::add(problem);
  ex_problems(problem_no).rebind(CAST_REF(problem,ExplicitODEeqUDC));

}

//-----------------------------------------------------------------------------
CombinedExplicitODE::CombinedExplicitODE(int no)
//-----------------------------------------------------------------------------
  : CombinedDynSys(no)
{ ex_problems.redim(no); }



//-----------------------------------------------------------------------------
void CombinedExplicitODE::evalStateDot
//-----------------------------------------------------------------------------
(
  Vec(real)& ydot,
  const DynamicState& s
  )

{
  CombinedDynamicState& ss = CAST_REF(s,CombinedDynamicState);
  comunicateBindTo(ss);

  // update part states containing the state received
  // (for communication between objects)
  // This means that within evalStateDot, the comState() refers to the
  // state given in the argument.

  real* ydtptr = ydot.getPtr0();
  int i;

  for (i = 1; i <= problem_no; i++)
    {
      ((VecSimplest(real)&)(ytemp)).redim(ydtptr,ss.part(i).size());

      ex_problems(i)->evalStateDot(ytemp, ss.part(i));
      ydtptr += ss.part(i).size();
    }


}
