#include <DynamicState.h>

INIT_CLASS_INFO(DynamicState)

//-------------------------------------------------------------------------
DynamicState::DynamicState(const DynamicState& state)
//-------------------------------------------------------------------------
{
  t =  &defaultT;
  redim(state.size(), state.noDiscrite());
  (*this)=(state);

}


//-------------------------------------------------------------------------
bool DynamicState::redim(int states, int discrites )
//-------------------------------------------------------------------------
{

  bool retv = getbool((y_.redim(states) &&
			     ydot_.redim(states)));

  if (discrites != 0)
    retv = getbool( retv && d_.redim(discrites));

  return retv;


}


//-------------------------------------------------------------------------
void DynamicState::print(Os& os) const
//-------------------------------------------------------------------------
{
  os << "t=" << time() << "\n";
  y_.print(os,"y=");
  ydot_.print(os,"ydot=");
  if (d_.size()>0) d_.print(os,"d=");
  else os << " d is empty !\n";
}


//-------------------------------------------------------------------------
 void  DynamicState::scan(Is& is)
//-------------------------------------------------------------------------
{
  char c;
  is->ignore('=');
  is >> defaultT;
  y_.scan(is);
  ydot_.scan(is);
  is->eat("\n\t ");
  is->get(c);

  if (c != 'd')
    {
      is->putback(c);
      d_.scan(is);
    }
}


//-------------------------------------------------------------------------
void DynamicState::makeItSimilar(Handle(DynamicState)& s)
//-------------------------------------------------------------------------
{
  s.rebind(new DynamicState(*this));
}
