#include <ODEsolver.h>

INIT_CLASS_INFO(ODEsolver)

//----------------------------------------------------------------------------
const Vec(real)& ODEsolver::errorVec() const
//----------------------------------------------------------------------------
{
  if (!error_computed)
    {
      errorFP("ODEsolver()::errorVec()",
              "No error estimate computed !");
    }

  return locerror;
}



//----------------------------------------------------------------------------
void ODEsolver::newIntegrate()
//----------------------------------------------------------------------------
{
 // leave warning until more teste have been performed :
//  warningFP("ODEsolver::newIntegrate",
//	    "Use with care the solvers are not much tested !\n");

  dynamic_system->init();
  // this is importen:
  current_state.rebind(dynamic_system->state());
  dynamic_system->state().makeItSimilar(last_state);
  no_of_states = current_state->size();
  no_of_discrites = current_state->noDiscrite();
  dynamic_system->setIV(current_state());
  last_state() = current_state();
  locerror.redim(no_of_states);
  locerror = 0;
  error_computed  = false;
  last_dt = 0;
  retrycount = 0;
}


//----------------------------------------------------------------------------
void ODEsolver::restartIntegrate()
//----------------------------------------------------------------------------
{
  // should be supported:
  if (current_state->noDiscrite() != no_of_discrites
      || current_state->size() != no_of_states)
    errorFP("ODEsolver::restartIntegrate",
	    "Sorry, not implemented, the dynamic state can not change"
	    "size during integration !" );


  last_state()=current_state();
  error_computed  = false;
  last_dt = 0;
  locerror = 0;
}
