
#include <TimeStepper.h>

INIT_CLASS_INFO(TimeStepper)

//-----------------------------------------------------------------------------
void TimeStepper::defineStatic (MenuSystem& menu, int level)
//-----------------------------------------------------------------------------
{
  MenuSystem:: makeSubMenuHeader (menu, "TimeStepper", "time", level, 'G');

  menu.addItem(level, "lower time", "lt" ,"start time","0.0","R");
  menu.addItem(level, "upper time", "ut" ,"end time","1.0","R");
  menu.addItem(level, "dt", "dt","initial time stepping parameter","0.1", "R");
}

//-----------------------------------------------------------------------------
void TimeStepper::scan (MenuSystem& menu)
//-----------------------------------------------------------------------------
{

  real lt = menu.get("lower time").getReal();
  real ut = menu.get("upper time").getReal();
  real dt = menu.get("dt").getReal();

  init(lt,ut,dt);

}


//------------------------------------------------------------------------
void TimeStepper::init(real lower_t,real upper_t,real initial_dt)
//-----------------------------------------------------------------------
{
  time = lower_t;
  lower_time = lower_t;
  upper_time= upper_t;
  delta = initial_dt;
  step = 0;
  prev_time = time;
  min_step_size = 10e-14;
  underflow_count = 0;
}
