#include <ODEsolver_prm.h>
#include <ExplicitODEsolver.h>
#include <ErkODEsolver.h>
#include <EmsODEsolver.h>


static const char* subclass_table_OdeSolver[] =
{
  "Euler1",
  "Euler2",
  "RungeKutta23",
  "RungeKutta4",
  "RungeKuttaF45",
  "RungeKuttaCK45",
  "RungeKuttaDP45",
  "AdamsMoulton4",
  NULL
};


const char** hierODEsolver () { return subclass_table_OdeSolver; }


ODEsolver* createODEsolver (ODEsolver_prm& pm)
{
  ODEsolver* ptr = NULL;
  String solver_tp = pm.solver_tp;

  if (EQ(solver_tp,Euler1))
    ptr = new Euler1(pm);
  else if (EQ(solver_tp,Euler2))
    ptr = new Euler2(pm);
  else if (EQ(solver_tp,RungeKutta23))
    ptr = new RungeKutta23(pm);
  else if (EQ(solver_tp,RungeKutta4))
    ptr = new RungeKutta4(pm);
  else if (EQ(solver_tp,RungeKuttaF45))
    ptr = new RungeKuttaF45(pm);
  else if (EQ(solver_tp,RungeKuttaCK45))
    ptr = new RungeKuttaCK45(pm);
  else if (EQ(solver_tp,RungeKuttaDP45))
    ptr = new RungeKuttaDP45(pm);
  else if (EQ(solver_tp,AdamsMoulton4))
   ptr = new AdamsMoulton4(pm);
  else
    errorFP("createODEsolver","Cannot make object of class %s",
	    solver_tp.chars());

  return ptr;
}
